const int frequencyPin = 0;   // Input pin
const int halfSecond   = 500; // Meassured time
int currentlyTesting   = 0;
int freqPinState       = LOW;
int freq               = 0;
int prevFreqPinState   = LOW;
unsigned long timer    = 0;

void setup() {
  Serial.begin(115200);
  pinMode(frequencyPin, INPUT);
  currentlyTesting = 0;
}

void loop() {
  // Are we currently testing?
  if (currentlyTesting == 0) {
    int bytesReady = Serial.available();
    if (bytesReady <= 0) {
      return;
    } else {
      // Clear all serial data then begin.
      while (Serial.read() != -1);
      currentlyTesting = 1;
      timer            = millis();
      freq             = 0;
    }
  }
  
  freqPinState = digitalRead(frequencyPin); // Reads State of Input Pin
  
  if (freqPinState == LOW) {
    prevFreqPinState = LOW;
  }
  
  if (freqPinState == HIGH && prevFreqPinState == LOW) {
    prevFreqPinState = freqPinState;
    freq++;
  }
  
  if ((millis() - timer) > halfSecond) {
    freq *= 2;            // Only measured for 1/4 of a second, need 4x value.
    Serial.println(freq); // Prints Frequency
    currentlyTesting = 0; // Resets Testing State
  }
}
